org.glassfish.jersey

## Class InjectionManagerProvider

- java.lang.Object
- - org.glassfish.jersey.InjectionManagerProvider

    public class InjectionManagerProvider
    extends Object

Utility class with static methods that extract `injection manager` from various JAX-RS components. This class can be used when no injection is possible by `Context` or `Inject` annotation due to character of provider but there is a need to get any service from `InjectionManager`.

Injections are not possible for example when a provider is registered as an instance on the client. In this case the runtime will not inject the instance as this instance might be used in other client runtimes too.

Example. This is the class using a standard injection:

         public static class MyWriterInterceptor implements WriterInterceptor {
             @Inject
             MyInjectedService service;

             @Override
             public void aroundWriteTo(WriterInterceptorContext context) throws IOException, WebApplicationException {
                 Something something = service.getSomething();
                 ...
             }

         }

If this injection is not possible then this construct can be used:

         public static class MyWriterInterceptor implements WriterInterceptor {

             @Override
             public void aroundWriteTo(WriterInterceptorContext context) throws IOException, WebApplicationException {
                 InjectionManager injectionManager = InjectionManagerProvider.getInjectionManager(context);
                 MyInjectedService service = injectionManager.getInstance(MyInjectedService.class);
                 Something something = service.getSomething();
                 ...
             }
         }

Note, that this injection support is intended mostly for injection of custom user types. JAX-RS types are usually available without need for injections in method parameters. However, when injection of custom type is needed it is preferred to use standard injections if it is possible rather than injection support provided by this class.

User returned `InjectionManager` only for purpose of getting services (do not change the state of the injection manager).

Since:
  2.6
Author:
  Miroslav Fuksa

### Constructor Summary

Constructors
Constructor and Description
`InjectionManagerProvider()`

### Method Summary

All Methods Static Methods Concrete Methods
`static org.glassfish.jersey.internal.inject.InjectionManager` `getInjectionManager(jakarta.ws.rs.core.FeatureContext featureContext)` Extract and return injection manager from `featureContext`.
`static org.glassfish.jersey.internal.inject.InjectionManager` `getInjectionManager(jakarta.ws.rs.ext.ReaderInterceptorContext readerInterceptorContext)` Extract and return injection manager from `readerInterceptorContext`.
`static org.glassfish.jersey.internal.inject.InjectionManager` `getInjectionManager(jakarta.ws.rs.ext.WriterInterceptorContext writerInterceptorContext)` Extract and return injection manager from `writerInterceptorContext`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### InjectionManagerProvider

    public InjectionManagerProvider()

### Method Detail

#### getInjectionManager

    public static org.glassfish.jersey.internal.inject.InjectionManager getInjectionManager(jakarta.ws.rs.ext.WriterInterceptorContext writerInterceptorContext)

Extract and return injection manager from `writerInterceptorContext`. The method can be used to inject custom types into a `WriterInterceptor`.

Parameters:
  `writerInterceptorContext` - Writer interceptor context.
Returns:
  injection manager.
Throws:
  `IllegalArgumentException` - when `writerInterceptorContext` is not a default Jersey implementation provided by Jersey as argument in the `WriterInterceptor.aroundWriteTo(jakarta.ws.rs.ext.WriterInterceptorContext)` method.

#### getInjectionManager

    public static org.glassfish.jersey.internal.inject.InjectionManager getInjectionManager(jakarta.ws.rs.ext.ReaderInterceptorContext readerInterceptorContext)

Extract and return injection manager from `readerInterceptorContext`. The method can be used to inject custom types into a `ReaderInterceptor`.

Parameters:
  `readerInterceptorContext` - Reader interceptor context.
Returns:
  injection manager.
Throws:
  `IllegalArgumentException` - when `readerInterceptorContext` is not a default Jersey implementation provided by Jersey as argument in the `ReaderInterceptor.aroundReadFrom(jakarta.ws.rs.ext.ReaderInterceptorContext)` method.

#### getInjectionManager

    public static org.glassfish.jersey.internal.inject.InjectionManager getInjectionManager(jakarta.ws.rs.core.FeatureContext featureContext)

Extract and return injection manager from `featureContext`. The method can be used to inject custom types into a `Feature`.

Note that features are utilized during initialization phase when not all providers are registered yet. It is undefined which injections are already available in this phase.

Parameters:
  `featureContext` - Feature context.
Returns:
  injection manager.
Throws:
  `IllegalArgumentException` - when `writerInterceptorContext` is not a default Jersey instance provided by Jersey in `Feature.configure(jakarta.ws.rs.core.FeatureContext)` method.